
function out = run_diagnostics(DET,P,FK,FCC);

% check if the model is forward convergent
if FCC(1) < 1000
   disp('Model is forward convergent'); 
end

out = 4;

if DET(2)<1
   if DET(1)<1
       disp('Your model is determinate');
       out = 1;
   else
       disp('There is no stable solution');
       out = 2;
   end
else
   Opt.ks = [0;1]; 
   tau2   = find_tau2(P,FK,Opt);
   
   if DET(1) < 1 && tau2 < 1
       disp('Your model is determinate');
       out = 1;
   end
   if DET(1)>=1 && tau2 < 1
       disp('Case 4');
       out = 3;
   end
end
